
// Report relativo caratteri, codici di Huffman e numeri di occorrenze
// in un file di testo (es.: sorgente di un programma Java)


import campus_toolkit.*;


public class HuffmanReport {


  private static final int BYTES = InputByteFile.BYTES;
  private static final String SPACE = "   ";
  
  
  // Tabella delle frequenze dei byte (caratteri)
  // src: nome del documento da analizzare
  // tab: nome del report (tabella)
  
  public static void report( String src, String dst ) {          // denominazioni del file di testo e del file-report

    int[] freqs = HuffmanCompression.byteHistogram( src );       // frequenze dei byte
    
    Node root = HuffmanCompression.huffmanTree( freqs );         // albero di Huffman
    
    String[] codes                                               // codici di Huffman
               = HuffmanCompression.huffmanCodesTable( root );
    
    OutputByteFile out = new OutputByteFile( dst );              // creazione del file-report
    
    for ( int b=0; b<BYTES; b=b+1 ) {                            // per ciascun byte
      
      if ( freqs[b] > 0 ) {                                      // se compare nel file src
      
        String ln = "" + (char) b;                               // byte interpretato come carattere
                                                                 // (codice ASCII)
        switch ( b ) {                                           // sostituzione leggibile per byte che sono
                                                                 // codici ASCII di caratteri speciali:
          case ' ' : {                                           // spazio bianco
            ln = "\\sp";
            break;
          }
          case '\n' : {                                          // fine linea
            ln = "\\n";
            break;
          }
          case '\r' : {                                          // capolinea
            ln = "\\r";
            break;
          }
          case '\t' : {                                          // tabulazione
            ln = "\\t";
            break;
          }
          default : {
            break;
        }}
        String code =  // codice di Huffman del byte b
        int freq =     // numero di occorrenze del byte b in src
        
        ln = ln + "\t" + code + "\t" + freq + "\n";              // linea di "stampa" ne report per il byte b
        
        for ( int i=0; i<ln.length(); i=i+1 ) {
        
          // scrittura dei byte che compongono la linea del report:
          
        }
    }}
    out.close();
  }


}  // class HuffmanReport

